NX Open C++ Reference Guide
Public Types | Public Member Functions | List of all members
NXOpen::Features::FitCurveBuilder Class Reference

Represents a NXOpen::Features::FitCurve builder
To create a new instance of this class, use NXOpen::Features::FeatureCollection::CreateFitCurveBuilder
Default values. More...

Inheritance diagram for NXOpen::Features::FitCurveBuilder:
NXOpen::Features::FeatureBuilder NXOpen::Builder NXOpen::TaggedObject NXOpen::GeometricUtilities::IComponentBuilder NXOpen::Features::SketchFitCurveBuilder

Public Types

enum  FittingParametersOptions { FittingParametersOptionsDegreeAndSegments, FittingParametersOptionsDegreeAndTolerance, FittingParametersOptionsTemplateCurve }
 Fitting parameters options. More...
 
enum  ProjectionDirectionOptions {
  ProjectionDirectionOptionsXc, ProjectionDirectionOptionsYc, ProjectionDirectionOptionsZc, ProjectionDirectionOptionsNormal,
  ProjectionDirectionOptionsView, ProjectionDirectionOptionsVector
}
 Auxiliary curve projection direction options. More...
 
enum  TargetSourceTypes {
  TargetSourceTypesInfer, TargetSourceTypesSpecifiedPoints, TargetSourceTypesChainedPoints, TargetSourceTypesCurve,
  TargetSourceTypesFace, TargetSourceTypesFacetBody
}
 Fitting target types. More...
 
enum  Types { TypesFitSpline, TypesFitLine, TypesFitCircle, TypesFitEllipse }
 Fitting types. More...
 

Public Member Functions

bool CanKeepTemplateSelected ()
 Returns the flag indicating if template curve should be kept selected
Created in NX8.5.0. More...
 
bool CanRejectPointsAutomatically ()
 Returns the flag indicating if points beyond a threshold value should be ignored during fitting
Created in NX8.5.0. More...
 
bool CanUseAllPointsInPart ()
 Returns the flag indicating if all points in the part can be used for chaining
Created in NX8.5.0. More...
 
void ChainAllPoints ()
 Chains all the points in work part based on one selected point and evaluates the curve. More...
 
NXOpen::Features::GeometricConstraintDataManagerConstraintManager ()
 Returns the constraint manager
Created in NX8.5.0. More...
 
int Degree ()
 Returns the degree
Created in NX8.5.0. More...
 
void DeleteTargetPoints (const std::vector< NXOpen::Point * > &points)
 Deletes target points
Created in NX8.5.0. More...
 
void Evaluate ()
 Evaluates the curve
Created in NX8.5.0. More...
 
NXOpen::GeometricUtilities::CurveExtensionBuilderExtender ()
 Returns the extension option
Created in NX8.5.0. More...
 
NXOpen::Features::FitCurveBuilder::FittingParametersOptions FittingParameters ()
 Returns the fitting parameters
Created in NX8.5.0. More...
 
NXOpen::PointGetFinalTargetPoint (int index)
 Returns the target point that are finally used for fitting. More...
 
int GetFinalTargetPointsSize ()
 Returns the number of target points that are finally used for fitting. More...
 
bool HasRadius ()
 Returns the has radius
Created in NX8.5.0. More...
 
bool HasReversedDirection ()
 Returns the flag indicating if fitted curve direction should be reversed
Created in NX8.5.0. More...
 
bool HasUniformSegments ()
 Returns the flag indicating if uniform segments should be created
Created in NX8.5.0. More...
 
bool IsAssociative ()
 Returns the flag indicating if a feature should be created
Created in NX8.5.0. More...
 
bool IsClosedBSpline ()
 Returns the flag indicating if a closed b-spline is to be fitted
Created in NX8.5.0. More...
 
bool IsClosedCurve ()
 Returns the flag indicating if a full circle or ellipse is to be fitted
Created in NX8.5.0. More...
 
void MakeConstraint (NXOpen::Point *point)
 In case of point targets, makes a target point a positional constraint. More...
 
NXOpen::DirectionProjectionDirection ()
 Returns the projection direction
Created in NX8.5.0. More...
 
NXOpen::Features::FitCurveBuilder::ProjectionDirectionOptions ProjectionDirectionOption ()
 Returns the projection direction option
Created in NX8.5.0. More...
 
NXOpen::ExpressionRadius ()
 Returns the circle radius
Created in NX8.5.0. More...
 
NXOpen::ExpressionRejectionThreshold ()
 Returns the rejection threshold
Created in NX8.5.0. More...
 
void RemoveConstraint (NXOpen::Point *point)
 Makes existing positional constraint a free target point
Created in NX8.5.0. More...
 
int Segments ()
 Returns the segments
Created in NX8.5.0. More...
 
void SetAssociative (bool associative)
 Sets the flag indicating if a feature should be created
Created in NX8.5.0. More...
 
void SetCanKeepTemplateSelected (bool canKeepTemplateSelected)
 Sets the flag indicating if template curve should be kept selected
Created in NX8.5.0. More...
 
void SetCanRejectPointsAutomatically (bool rejectPoints)
 Sets the flag indicating if points beyond a threshold value should be ignored during fitting
Created in NX8.5.0. More...
 
void SetCanUseAllPointsInPart (bool canUseAllPointsInPart)
 Sets the flag indicating if all points in the part can be used for chaining
Created in NX8.5.0. More...
 
void SetClosedBSpline (bool isClosed)
 Sets the flag indicating if a closed b-spline is to be fitted
Created in NX8.5.0. More...
 
void SetClosedCurve (bool isClosed)
 Sets the flag indicating if a full circle or ellipse is to be fitted
Created in NX8.5.0. More...
 
void SetDegree (int degree)
 Sets the degree
Created in NX8.5.0. More...
 
void SetFittingParameters (NXOpen::Features::FitCurveBuilder::FittingParametersOptions fittingParameters)
 Sets the fitting parameters
Created in NX8.5.0. More...
 
void SetHasRadius (bool hasRadius)
 Sets the has radius
Created in NX8.5.0. More...
 
void SetHasReversedDirection (bool hasReversedDirection)
 Sets the flag indicating if fitted curve direction should be reversed
Created in NX8.5.0. More...
 
void SetHasUniformSegments (bool hasUniformSegments)
 Sets the flag indicating if uniform segments should be created
Created in NX8.5.0. More...
 
void SetProjectionDirection (NXOpen::Direction *projectionDirection)
 Sets the projection direction
Created in NX8.5.0. More...
 
void SetProjectionDirectionOption (NXOpen::Features::FitCurveBuilder::ProjectionDirectionOptions projectionDirectionOption)
 Sets the projection direction option
Created in NX8.5.0. More...
 
void SetSegments (int segments)
 Sets the segments
Created in NX8.5.0. More...
 
void SetTargetSourceType (NXOpen::Features::FitCurveBuilder::TargetSourceTypes targetSourceType)
 Sets the target type
Created in NX8.5.0. More...
 
void SetTolerance (double tolerance)
 Sets the tolerance
Created in NX8.5.0. More...
 
void SetType (NXOpen::Features::FitCurveBuilder::Types type)
 Sets the type
Created in NX8.5.0. More...
 
NXOpen::SelectTaggedObjectListTarget ()
 Returns the target objects. More...
 
NXOpen::Features::FitCurveBuilder::TargetSourceTypes TargetSourceType ()
 Returns the target type
Created in NX8.5.0. More...
 
NXOpen::SelectSplineTemplateCurve ()
 Returns the template curve
Created in NX8.5.0. More...
 
double Tolerance ()
 Returns the tolerance
Created in NX8.5.0. More...
 
NXOpen::Features::FitCurveBuilder::Types Type ()
 Returns the type
Created in NX8.5.0. More...
 
void UpdateTargetSelectionOnPointEditing ()
 Updates target selection by replacing original point by edited point. More...
 
- Public Member Functions inherited from NXOpen::Features::FeatureBuilder
NXOpen::Features::FeatureCommitFeature ()
 Commits the feature parameters and creates the feature. More...
 
NXOpen::Features::FeatureGetFeature ()
 Returns the feature currently being edited by this builder. More...
 
void HideInternalParentFeatureAfterEdit (NXOpen::Features::Feature *parentFeature)
 Re-suppress an internal parent feature (a slave feature) after it has been edited. More...
 
bool ParentFeatureInternal ()
 Returns whether or not the latest timestamped parent feature of this feature should be made internal
Created in NX5.0.0. More...
 
bool PatchSolutionFlag ()
 Returns the patch solution flag
Created in NX8.0.1. More...
 
NXString PatchSurfaceFilename ()
 Returns the patch surface filename
Created in NX8.0.1. More...
 
void SetParentFeatureInternal (NXOpen::Features::Feature *parentFeature)
 Set the parent features which would be internal or slaves to the feature being created or commited
Created in NX6.0.0. More...
 
void SetParentFeatureInternal (bool isInternal)
 Sets whether or not the latest timestamped parent feature of this feature should be made internal
Created in NX5.0.0. More...
 
void SetPatchSolutionFlag (bool optionValue)
 Sets the patch solution flag
Created in NX8.0.1. More...
 
void SetPatchSurfaceFilename (const NXString &surfaceFilename)
 Sets the patch surface filename
Created in NX8.0.1. More...
 
void SetPatchSurfaceFilename (const char *surfaceFilename)
 Sets the patch surface filename
Created in NX8.0.1. More...
 
void SetSurroundingPatchSurfaceFilename (const NXString &surroundingSurfaceFilename)
 Sets the surrounding patch surface filename
Created in NX8.0.1. More...
 
void SetSurroundingPatchSurfaceFilename (const char *surroundingSurfaceFilename)
 Sets the surrounding patch surface filename
Created in NX8.0.1. More...
 
void ShowInternalParentFeatureForEdit (NXOpen::Features::Feature *parentFeature)
 Unsuppress an internal parent feature (a slave feature) so it can be edited. More...
 
NXString SurroundingPatchSurfaceFilename ()
 Returns the surrounding patch surface filename
Created in NX8.0.1. More...
 
void UnsetParentFeatureInternal (NXOpen::Features::Feature *parentFeature)
 Set the internal parent feature of the feature being edited to external
Created in NX6.0.0. More...
 
- Public Member Functions inherited from NXOpen::Builder
NXOpen::NXObjectCommit ()
 Commits any edits that have been applied to the builder. More...
 
void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
std::vector< NXOpen::NXObject * > GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
NXOpen::NXObjectGetObject ()
 Returns the object currently being edited by this builder. More...
 
void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
virtual bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen::TaggedObject
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

Represents a NXOpen::Features::FitCurve builder
To create a new instance of this class, use NXOpen::Features::FeatureCollection::CreateFitCurveBuilder
Default values.

Property Value

Extender.EndExtensionOption

None

Extender.EndValue.Value

0 (millimeters part), 0 (inches part)

Extender.StartExtensionOption

None

Extender.StartValue.Value

0 (millimeters part), 0 (inches part)

IsClosedCurve

true

ProjectionDirectionOption

Normal

Radius.Value

50.0 (millimeters part), 2.0 (inches part)

RejectionThreshold.Value

10.0 (millimeters part), 0.5 (inches part)


Created in NX8.5.0.

Member Enumeration Documentation

Fitting parameters options.

Enumerator
FittingParametersOptionsDegreeAndSegments 

Fit to degree and segments.

FittingParametersOptionsDegreeAndTolerance 

Fit to degree and tolerance.

FittingParametersOptionsTemplateCurve 

Fit to template spline.

Auxiliary curve projection direction options.

Enumerator
ProjectionDirectionOptionsXc 

WCS X axis.

ProjectionDirectionOptionsYc 

WCS Y axis.

ProjectionDirectionOptionsZc 

WCS Z axis.

ProjectionDirectionOptionsNormal 

Face normal.

ProjectionDirectionOptionsView 

View.

ProjectionDirectionOptionsVector 

Vector.

Fitting target types.

Enumerator
TargetSourceTypesInfer 

Infer target from selection.

TargetSourceTypesSpecifiedPoints 

Specified points.

TargetSourceTypesChainedPoints 

Chain using one or two points.

TargetSourceTypesCurve 

Curve.

TargetSourceTypesFace 

Face.

TargetSourceTypesFacetBody 

Facet body.

Fitting types.

Enumerator
TypesFitSpline 

Fits a spline.

TypesFitLine 

Fits a line.

TypesFitCircle 

Fits an arc or a circle.

TypesFitEllipse 

Fits an ellipse.

Member Function Documentation

bool NXOpen::Features::FitCurveBuilder::CanKeepTemplateSelected ( )

Returns the flag indicating if template curve should be kept selected
Created in NX8.5.0.



License requirements : None

bool NXOpen::Features::FitCurveBuilder::CanRejectPointsAutomatically ( )

Returns the flag indicating if points beyond a threshold value should be ignored during fitting
Created in NX8.5.0.



License requirements : None

bool NXOpen::Features::FitCurveBuilder::CanUseAllPointsInPart ( )

Returns the flag indicating if all points in the part can be used for chaining
Created in NX8.5.0.



License requirements : None

void NXOpen::Features::FitCurveBuilder::ChainAllPoints ( )

Chains all the points in work part based on one selected point and evaluates the curve.

Operation is valid for NXOpen::Features::FitCurveBuilder::TargetSourceTypesInfer only.
Created in NX8.5.0.

License requirements : solid_modeling ("SOLIDS MODELING")

NXOpen::Features::GeometricConstraintDataManager* NXOpen::Features::FitCurveBuilder::ConstraintManager ( )

Returns the constraint manager
Created in NX8.5.0.



License requirements : None

int NXOpen::Features::FitCurveBuilder::Degree ( )

Returns the degree
Created in NX8.5.0.



License requirements : None

void NXOpen::Features::FitCurveBuilder::DeleteTargetPoints ( const std::vector< NXOpen::Point * > &  points)

Deletes target points
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
pointsOne of the original target points or one of the constraint manager points to remove a constraint of
void NXOpen::Features::FitCurveBuilder::Evaluate ( )

Evaluates the curve
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

NXOpen::GeometricUtilities::CurveExtensionBuilder* NXOpen::Features::FitCurveBuilder::Extender ( )

Returns the extension option
Created in NX8.5.0.



License requirements : None

NXOpen::Features::FitCurveBuilder::FittingParametersOptions NXOpen::Features::FitCurveBuilder::FittingParameters ( )

Returns the fitting parameters
Created in NX8.5.0.



License requirements : None

NXOpen::Point* NXOpen::Features::FitCurveBuilder::GetFinalTargetPoint ( int  index)

Returns the target point that are finally used for fitting.

Returns

Created in NX8.5.0.

License requirements : solid_modeling ("SOLIDS MODELING")
Parameters
indexindex
int NXOpen::Features::FitCurveBuilder::GetFinalTargetPointsSize ( )

Returns the number of target points that are finally used for fitting.

Returns

Created in NX8.5.0.

License requirements : solid_modeling ("SOLIDS MODELING")
bool NXOpen::Features::FitCurveBuilder::HasRadius ( )

Returns the has radius
Created in NX8.5.0.



License requirements : None

bool NXOpen::Features::FitCurveBuilder::HasReversedDirection ( )

Returns the flag indicating if fitted curve direction should be reversed
Created in NX8.5.0.



License requirements : None

bool NXOpen::Features::FitCurveBuilder::HasUniformSegments ( )

Returns the flag indicating if uniform segments should be created
Created in NX8.5.0.



License requirements : None

bool NXOpen::Features::FitCurveBuilder::IsAssociative ( )

Returns the flag indicating if a feature should be created
Created in NX8.5.0.



License requirements : None

bool NXOpen::Features::FitCurveBuilder::IsClosedBSpline ( )

Returns the flag indicating if a closed b-spline is to be fitted
Created in NX8.5.0.



License requirements : None

bool NXOpen::Features::FitCurveBuilder::IsClosedCurve ( )

Returns the flag indicating if a full circle or ellipse is to be fitted
Created in NX8.5.0.



License requirements : None

void NXOpen::Features::FitCurveBuilder::MakeConstraint ( NXOpen::Point point)

In case of point targets, makes a target point a positional constraint.

In case of other targets, makes one of the specified points a positional constraint
Created in NX8.5.0.

License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
pointOne of the original target points to make a constraint of
NXOpen::Direction* NXOpen::Features::FitCurveBuilder::ProjectionDirection ( )

Returns the projection direction
Created in NX8.5.0.



License requirements : None

NXOpen::Features::FitCurveBuilder::ProjectionDirectionOptions NXOpen::Features::FitCurveBuilder::ProjectionDirectionOption ( )

Returns the projection direction option
Created in NX8.5.0.



License requirements : None

NXOpen::Expression* NXOpen::Features::FitCurveBuilder::Radius ( )

Returns the circle radius
Created in NX8.5.0.



License requirements : None

NXOpen::Expression* NXOpen::Features::FitCurveBuilder::RejectionThreshold ( )

Returns the rejection threshold
Created in NX8.5.0.



License requirements : None

void NXOpen::Features::FitCurveBuilder::RemoveConstraint ( NXOpen::Point point)

Makes existing positional constraint a free target point
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
pointOne of the original target points or one of the constraint manager points to remove a constraint of
int NXOpen::Features::FitCurveBuilder::Segments ( )

Returns the segments
Created in NX8.5.0.



License requirements : None

void NXOpen::Features::FitCurveBuilder::SetAssociative ( bool  associative)

Sets the flag indicating if a feature should be created
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
associativeassociative
void NXOpen::Features::FitCurveBuilder::SetCanKeepTemplateSelected ( bool  canKeepTemplateSelected)

Sets the flag indicating if template curve should be kept selected
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
canKeepTemplateSelectedcankeeptemplateselected
void NXOpen::Features::FitCurveBuilder::SetCanRejectPointsAutomatically ( bool  rejectPoints)

Sets the flag indicating if points beyond a threshold value should be ignored during fitting
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
rejectPointsrejectpoints
void NXOpen::Features::FitCurveBuilder::SetCanUseAllPointsInPart ( bool  canUseAllPointsInPart)

Sets the flag indicating if all points in the part can be used for chaining
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
canUseAllPointsInPartcanuseallpointsinpart
void NXOpen::Features::FitCurveBuilder::SetClosedBSpline ( bool  isClosed)

Sets the flag indicating if a closed b-spline is to be fitted
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
isClosedisclosed
void NXOpen::Features::FitCurveBuilder::SetClosedCurve ( bool  isClosed)

Sets the flag indicating if a full circle or ellipse is to be fitted
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
isClosedisclosed
void NXOpen::Features::FitCurveBuilder::SetDegree ( int  degree)

Sets the degree
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
degreedegree
void NXOpen::Features::FitCurveBuilder::SetFittingParameters ( NXOpen::Features::FitCurveBuilder::FittingParametersOptions  fittingParameters)

Sets the fitting parameters
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
fittingParametersfittingparameters
void NXOpen::Features::FitCurveBuilder::SetHasRadius ( bool  hasRadius)

Sets the has radius
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
hasRadiushasradius
void NXOpen::Features::FitCurveBuilder::SetHasReversedDirection ( bool  hasReversedDirection)

Sets the flag indicating if fitted curve direction should be reversed
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
hasReversedDirectionhasreverseddirection
void NXOpen::Features::FitCurveBuilder::SetHasUniformSegments ( bool  hasUniformSegments)

Sets the flag indicating if uniform segments should be created
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
hasUniformSegmentshasuniformsegments
void NXOpen::Features::FitCurveBuilder::SetProjectionDirection ( NXOpen::Direction projectionDirection)

Sets the projection direction
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
projectionDirectionprojectiondirection
void NXOpen::Features::FitCurveBuilder::SetProjectionDirectionOption ( NXOpen::Features::FitCurveBuilder::ProjectionDirectionOptions  projectionDirectionOption)

Sets the projection direction option
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
projectionDirectionOptionprojectiondirectionoption
void NXOpen::Features::FitCurveBuilder::SetSegments ( int  segments)

Sets the segments
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
segmentssegments
void NXOpen::Features::FitCurveBuilder::SetTargetSourceType ( NXOpen::Features::FitCurveBuilder::TargetSourceTypes  targetSourceType)

Sets the target type
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
targetSourceTypetargetsourcetype
void NXOpen::Features::FitCurveBuilder::SetTolerance ( double  tolerance)

Sets the tolerance
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
tolerancetolerance
void NXOpen::Features::FitCurveBuilder::SetType ( NXOpen::Features::FitCurveBuilder::Types  type)

Sets the type
Created in NX8.5.0.



License requirements : solid_modeling ("SOLIDS MODELING")

Parameters
typetype
NXOpen::SelectTaggedObjectList* NXOpen::Features::FitCurveBuilder::Target ( )

Returns the target objects.

Inputs to this command can be convergent objects.
Created in NX8.5.0.

License requirements : None

NXOpen::Features::FitCurveBuilder::TargetSourceTypes NXOpen::Features::FitCurveBuilder::TargetSourceType ( )

Returns the target type
Created in NX8.5.0.



License requirements : None

NXOpen::SelectSpline* NXOpen::Features::FitCurveBuilder::TemplateCurve ( )

Returns the template curve
Created in NX8.5.0.



License requirements : None

double NXOpen::Features::FitCurveBuilder::Tolerance ( )

Returns the tolerance
Created in NX8.5.0.



License requirements : None

NXOpen::Features::FitCurveBuilder::Types NXOpen::Features::FitCurveBuilder::Type ( )

Returns the type
Created in NX8.5.0.



License requirements : None

void NXOpen::Features::FitCurveBuilder::UpdateTargetSelectionOnPointEditing ( )

Updates target selection by replacing original point by edited point.

When a target point is edited by dragging, the originally selected target point gets replaced by another point representing edited location. Thus it is no longer necessary for original point to remain selected.


Created in NX8.5.0.

License requirements : solid_modeling ("SOLIDS MODELING")


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.